<?php
class VisitorController {

    function __construct() 
    {
        
        global $rep,$vues;
        //session_start();

        $dVueEreur = array ();

        try {
            $action = $_REQUEST['action']??null;
            switch($action) {
                case NULL:
                    $this->Reinit();
                    break;
                case "goHome":
                    $this->Reinit();
                    break;

                case "signIn":
                    $this->Connection($dVueEreur);
                    break;
                case "signUp":
                    $this->Inscription($dVueEreur);
                    break;

                case "accessSignIn":
                    require($rep.$vues['signIn']);
                    break;
                case "accessSignUp":
                    require($rep.$vues['signUp']);
                    break;

                case "accessAddListVis":
                    require($rep.$vues['addListVis']);
                    break;

                case "accessAddTask":
                    $dataView=$_POST['list'];
                    require($rep.$vues['addTask']);
                    break;
                case "accessModifyTask":
                    $mdlTache= new MdlTache();
                    $tache=$mdlTache->findById($_POST['task']);
                    $dataView[]=$tache;
                    $dataView[]=$_POST['list'];
                    require($rep.$vues['modifyTask']);
                    break;
                case "accessModifyListPub":
                    $mdlListe= new MdlListe();
                    $liste=$mdlListe->findById($_POST['list']);
                    $dataView=$liste[0];
                    require($rep.$vues['modifyListPub']);
                    break;

                case "modifyPublicList":
                    $this->ModifyListPub($dVueEreur);
                    break;

                case "addListVis":
                    $this->AddList($dVueEreur);
                    break;

                case "delList":
                    $this->DelList($dVueEreur);
                    break;
                case "accessListInfos":
                    $this->accessListInfos($dVueEreur);
                    break;
                
                case "addTask":
                    $this->AddTask($dVueEreur);
                    break;

                case "deleteTask":
                    $this->DelTask($dVueEreur);
                    break;

                case "modifyTask":
                    $this->UpdateTask($dVueEreur);
                    break;

                default:
                    $dVueEreur[] =	"Erreur d'appel php";
                    require ($rep.$vues['accueil']);
                    break;
            }
        }
        catch (Exception $e){
        }
    }

    public function Reinit(){
        global $rep,$vues,$dataView,$styles;
        $model = new MdlListe();
        $dataView = $model->getPublicList();
        require($rep.$vues['accueil']);
        $dVueEreur= array();
    }

    function AddList($dVueEreur) {
        global $rep, $vues, $dataView;

        $name=$_POST['name'];

        $dVueEreur=Validation::val_intitule($name, $dVueEreur);

        try {
            if(!empty($dVueEreur)){
                require($rep.$vues['addListVis']);
            }
            else{
                $model= new MdlListe();
                $list=[];
                $list[]=$model->insert($name, false, null);
                $dataView=$list;
                require($rep.$vues['seeList']);
            }
        } 
        catch (PDOException $e) {
            $dataView[]="Erreur inatendue";
            require($rep.$vues['erreur']);
        }
    }



    public function Inscription(array $dVueEreur){
        global $rep,$vues,$dataView;
        $username=$_POST['username']; 
        $password=$_POST['password'];
        $confirm=$_POST['passwordconf'];
        $model = new MdlUser();
        $dVueEreur=Validation::val_inscription($username,$password,$confirm,$dVueEreur);
        if($model->existUser($username)){
            $dVueEreur[]="Username already taken";
        }
        if(empty($dVueEreur)){
            $hash= password_hash($password,PASSWORD_DEFAULT);
            $model->signUp($username,$hash);
            $dVueEreur= array();
            $_REQUEST['action']=null;
            $this->reinit();
        }
        else{
            require($rep.$vues['signUp']);
        }
    }

    public function Connection(array $dVueEreur){
        global $rep,$vues,$dataView;
        $username=$_POST['username']; 
        $password=$_POST['password'];
        $dVueEreur=Validation::val_connexion($username,$password,$dVueEreur);
        if(!empty($dVueEreur)){
            require($rep.$vues['signIn']);
        }
        $model= new MdlUser();
        if($model->existUser($username)){

            if(password_verify($password,$model->getPasswordHash($username))){
                $model->connexion($username);
                $_REQUEST['action']=null;
                $this->reinit();
                $dVueEreur= array();
            }
            else{
                $dVueEreur =array('username'=>$username,'password'=>$password);
                require($rep.$vues['signIn']);
            }
        }
        else{
            $dVueEreur =array('username'=>$username,'password'=>$password);
            require($rep.$vues['signIn']);
        }
    }

    function DelList($dVueEreur) {
        global $rep,$vues,$dataView;
        $idListe=$_POST['list'];
        $model = new MdlListe();
        $model->delete($idListe);
        $_REQUEST['action']=null;
        $this->reinit();  
        $dVueEreur= array();
    }

    function AddTask($dVueEreur) {
        global $rep,$vues,$dataView;
        $nom=$_POST['name'];
        $idListe=$_POST['list'];
        $content=$_POST['content'];
        if(!isset($_POST['completed']))
        {
            $completed = false;
        } else {
            $completed = $_POST['completed'];
        }

        $dVueEreur = Validation::val_intitule($nom, $dVueEreur);
        if (empty($dVueEreur)){
            $dVueEreur = Validation::val_intitule($content, $dVueEreur);
        }
        if(!empty($dVueEreur)){
            $dataView=$_POST['list'];
            require($rep.$vues['addTask']);
        }
        else{
            $model = new MdlTache();
            $model->insert($nom, $content, $completed, $idListe);
            $_REQUEST['action']="accessListInfos";
            $this->accessListInfos($dVueEreur);
        }
        $dVueEreur= array();
    }

    function accessListInfos($dVueEreur){
        global $rep,$vues,$dataView;
        $idListe=$_POST['list'];
        $model = new MdlListe();
        $dataView = $model->findById($idListe);
        require($rep.$vues['seeList']);
        $dVueEreur= array();
    }

    function DelTask($dVueEreur) {
        global $rep,$vues,$dataView;
        $idTache=$_POST['tache'];
        $model= new MdlTache();
        $model->delete($idTache);
        $_REQUEST['action']="accessListInfos";
        $this->accessListInfos($dVueEreur);
        $dVueEreur= array();
    }

    function UpdateTask($dVueEreur) {
        global $rep,$vues,$dataView;
        $list=$_POST['list'];
        $tache=$_POST['task'];
        $name=$_POST['name'];
        $content=$_POST['content'];
        $model = new MdlTache();
        if(!isset($_POST['completed']))
        {
            $completed = false;
        } else {
            $completed = $_POST['completed'];
        }

        $dVueEreur = Validation::val_intitule($name, $dVueEreur);
        if (empty($dVueEreur)){
            $dVueEreur = Validation::val_intitule($content, $dVueEreur);
        }
        if(!empty($dVueEreur)){
            $mdlTache= new MdlTache();
            $tache=$mdlTache->findById($_POST['task']);
            $dataView[]=$tache;
            $dataView[]=$_POST['list'];
            require($rep.$vues['modifyTask']);
        }
        else{
            $tache=$model->findById($_POST['task']);
            $model->update($tache, $name, $content, $completed);
            $_REQUEST['action']="accessListInfos";
            $this->accessListInfos($dVueEreur);
            $dVueEreur= array();
        }

    }

    function ModifyListPub($dVueEreur){
        global $rep,$vues,$dataView;
        $list=$_POST['list'];
        $name=$_POST['name'];
        $model = new MdlListe();
        $dVueEreur = Validation::val_intitule($name, $dVueEreur);
        if(!empty($dVueEreur)){
            $liste=$mdlListe->findById($list);
            $dataView=$liste[0];
            require($rep.$vues['modifyListPub']);
        }
        else{
            $mdlUsr = new MdlUser();
            $list=$model->findById($list);
            $model->update($list[0], $name, false);
            $_REQUEST['action']="accessListInfos";
            $this->accessListInfos($dVueEreur);
            $dVueEreur= array();
        }
        
    }
}
?>